var restartFirefox = {
	localizedText : "Restart",
	neverAskText : "Don't ask me next time",
	ver : null,
	warnOnRestart : true,

	// setup the strings above
	init : function () {
		var strings = Components.classes["@mozilla.org/intl/stringbundle;1"]
								  .createInstance(Components.interfaces.nsIStringBundleService);
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
						 .getService(Components.interfaces.nsIXULAppInfo);
		restartFirefox.ver = parseFloat(appInfo.version);

		var prefsService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = prefsService.getBranch("browser.");

		// figure out the strings
		if(restartFirefox.ver>=3) {
			var quitBundle = strings.createBundle("chrome://browser/locale/quitDialog.properties");
			restartFirefox.localizedText = quitBundle.GetStringFromName("restartTitle").replace(/&/,"").replace(/\(.\)/,"");	// &Restart (R)
			restartFirefox.neverAskText = quitBundle.GetStringFromName("neverAsk");
			restartFirefox.warnOnRestart = prefs.getBoolPref("warnOnRestart");
		} else if(restartFirefox.ver<3 && restartFirefox.ver>=2) {
			var extBundle = strings.createBundle("chrome://mozapps/locale/extensions/extensions.properties");
			var brandBundle = strings.createBundle("chrome://branding/locale/brand.properties");
			var app = brandBundle.GetStringFromName("brandShortName");
			restartFirefox.localizedText = extBundle.formatStringFromName("restartButton", [app], 1);
			var askBundle = strings.createBundle("chrome://global/locale/nsProgressDialog.properties");
			restartFirefox.neverAskText = askBundle.GetStringFromName("dontAskAgain");
		} else {
			//for version 1.5, don't bother localizing
		}
		try {
		// ff1&2 don't have this setting, it's custom
		restartFirefox.warnOnRestart = prefs.getBoolPref('warnOnRestart');
		} catch(e) {}
	},

	localizeOptions : function() {
		restartFirefox.init();
		window.document.getElementById("restartSettings").label = restartFirefox.localizedText;
		window.document.getElementById("donothing").title = restartFirefox.localizedText;
		window.document.getElementById("prefCheckbox").label = restartFirefox.neverAskText;
	},

	localizeWindows : function() {
		restartFirefox.init();
		var menu1 = window.document.getElementById("restartfirefox-fileMenu")
		if(menu1) menu1.label = restartFirefox.localizedText;
		var menu2 = window.document.getElementById("restartfirefox-fileMenu2")
		if(menu2) menu2.label = restartFirefox.localizedText;
		var button = window.document.getElementById("restartfirefox-button");
		if(button) {
			button.setAttribute("tooltiptext", restartFirefox.localizedText);
			button.setAttribute("label", restartFirefox.localizedText);
		}
	},

// main restart logic
	ourRestart : function() {
		restartFirefox.init();
		if(restartFirefox.warnOnRestart) {
			if(restartFirefox.ver>=3) if(!restartFirefox.ourDialog()) return;
			if(restartFirefox.ver<3) if(!confirm(restartFirefox.localizedText)) return;
		}
		nsIAppStartup = Components.interfaces.nsIAppStartup;

    var cancelQuit = Components.classes["@mozilla.org/supports-PRBool;1"]
                     .createInstance(Components.interfaces.nsISupportsPRBool);


    var gObserverService = Components.classes["@mozilla.org/observer-service;1"]
                                 .getService(Components.interfaces.nsIObserverService);

    gObserverService.notifyObservers(cancelQuit, "quit-application-requested",
                                 "restart");
    if (cancelQuit.data)
      return; // somebody canceled our quit request

		Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(nsIAppStartup)
			.quit(nsIAppStartup.eRestart | nsIAppStartup.eAttemptQuit);
	},

// from mozilla source, ask user about restarting
// uses strings from ff3+
	ourDialog : function() {
		var buttonChoice = 0;
		var bundleService = Cc["@mozilla.org/intl/stringbundle;1"].
						 getService(Ci.nsIStringBundleService);
		var quitBundle = bundleService.createBundle("chrome://browser/locale/quitDialog.properties");
		var brandBundle = bundleService.createBundle("chrome://branding/locale/brand.properties");

		var appName = brandBundle.GetStringFromName("brandShortName");
		var quitDialogTitle = quitBundle.formatStringFromName("restart" + "DialogTitle",
															 [appName], 1);

		var message;
		message = quitBundle.formatStringFromName("messageRestart",
												 [appName], 1);

		var promptService = Cc["@mozilla.org/embedcomp/prompt-service;1"].
						 getService(Ci.nsIPromptService);

		var flags = promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
				 promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1 +
				 promptService.BUTTON_POS_0_DEFAULT;

		var neverAsk = {value:false};
		var button0Title, button2Title;
		var button1Title = quitBundle.GetStringFromName("cancelTitle");

		button0Title = quitBundle.GetStringFromName("restartTitle");

		buttonChoice = promptService.confirmEx(null, quitDialogTitle, message,
								  flags, button0Title, button1Title, button2Title,
								  restartFirefox.neverAskText, neverAsk);

		switch (buttonChoice) {
			case 1: // Cancel
				return false;
			case 0: // Restart
				var prefBranch = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);
				prefBranch.setBoolPref("browser.sessionstore.resume_session_once", true);
				if (neverAsk.value) {
				   prefBranch.setBoolPref("browser.warnOnRestart", false);
				}
				return true;
		}
	}

};